local _G = _G;
local GetTime = GetTime
local string, ipairs = string, ipairs
local table_insert, table_remove , table_getn = table.insert, table.remove, table.getn
local print, string_format, string_gmatch = print, string.format, string.gmatch
local red = RED_FONT_COLOR
local UnrealTargets = CreateFrame('Frame', "UnrealTargets", UIParent)
local testbar
local newtabs = true
local unitdb = {}
unitdb.frostwolf = {}
unitdb.units = {}
unitdb.unitsmaxhp = {}

unitdb.ignornpc = {47649 -- wildpilz
	,95582 -- Armee der toten
	,24207 -- Vogel
	,15439 -- Totem des Feuerelementars
	,29264 -- Geisterwolf
	,82521 -- Entweihen
	,3527 -- Totem des heilenden Flusses
	,60199 -- Rune der Macht
	,47243 -- Spiegelbild
	,59764 -- Totem der Heilungsflut
	,77789 -- Blingtron 5000
	,416 -- Wichtel
	,31216 -- Spiegelbild
	,5929 -- Totem des glühenden Magmas
	,93828 -- Trainingsattrappe
	,45322 -- Gefrorene Kugel
	,62982 -- Geistbeuger
	,61245 -- Totem der Energiespeicherung
	,54983 -- Treant
	,77934 -- Totem des Sturmelementars
	,77936 -- Großer Sturmelementar
	,55659 -- Wildwichtel
	,2523 -- Totem der Verbrennung
	,90610 -- Teufelsfeuermunition
	,78158 -- Verdammniswache
	,15438 -- Großer Feuerelementar
	,46490 -- Wächter der Uralten Könige
	,53006 -- Totem der Geistverbindung
	,59000 -- Terrorwache
	,47319 -- Gezielter Sprung
	,60849 -- Statue der Jadeschlange
	,92993 -- Spiegelbild
	,63508 -- Xuen
	,92624 -- Streitkolben
	,76168 -- Verheerer
	,92587 -- Schwert
	,92919 -- Restenergie
	,76933 -- Kristallprisma
	,11859 -- Verdammniswache
	,27893 -- Runenklinge
	,73967 -- Xuen
	,61146 -- Statue des Schwarzen Ochsen
	,35642 -- Jeeves
	,94729 -- Kohlenbecken des Erwachens
	,59607 -- Spektralerscheinung
	,59712 -- Totem des Steinbollwerks
	,96115 -- Schlachtstandarte von Vol'jins Kopfjägern
	,94852 -- Feenmondschwinge
	,19668 -- Schattengeist
	,89194 -- Ausgedörrte Echse
	,94922 -- Lady Jaina Prachtmeer
	,94946 -- Arthas Menethil
	,94879 -- Tyrande Wisperwind
	,92893 -- Axt
	,94925 -- Fürstin Sylvanas Windläufer
	,77726 -- Schattenreflexion
	,27829 -- Schwarzer Gargoyle
	,54569 -- Transzendenzgeist
	,76917 -- <Persönliches Hologramm>
	,5925 -- Totem der Erdung
	,15352 -- Großer Erdelementar
	,15430 -- Totem des Erdelementars
	,61029 -- Urfeuerelementar
	,60561 -- Totem des Erdgriffs
	,64571 -- Lichtbrunnen
	,61056 -- Urerdelementar
	,40703 -- Megazord
	,91326 -- Gul'dan
	,59717 -- Totem des Windwandelns
	,5913 -- Totem des Erdstoßes
	,92208 -- Verdammnisfeuergeist
	,59738 -- Hammer des Lichts
	,4277 -- Auge von Kilrogg
	,67235 -- Schattengeist
	,80302 -- Wächterkugel
	,86945 -- Hexenmeisterin von Haus Sonnenschwur
	,89 -- Höllenbestie
	,86933 -- Magierin des Kriegsspeers
	,69680 -- Sturmgeist
	,58542 -- Vergangenes Selbst
	 ,88380 -- Grunzerin
	,88393 -- Grunzerin
	,88391 -- Garnisonsschütze
	,67236 -- Geistbeuger
	,95455 -- Verderbter urzeitlicher Obelisk
	,88435 -- Wächter der Schmiede
	,78215 -- Verirorok
	,61711 -- Wassertotem
	,61714 -- Lufttotem
	,61713 -- Erdtotem
	,69792 -- Erdgeist
	,77942 -- Ursturmelementar
	,87061 -- Schattengeist
	,88050 -- Frostwolf
	,31897 -- Lichtbrunnen
	,86946 -- Ausgestoßener Krallenpriester
	,62182 -- Amethystschieferjungtier
	,86964 -- Erdbinder der Blutmähnen
	,58997 -- Abyssal
	,86682 -- Pensionierter gorianischer Zenturio
	}

-- 90432 FAIL	
	
function cmdut(arg)
	
	if arg == "test" then
		local ignornpcid = false
		local guid = UnitGUID("target") 
		local _, _, _, _, _, npc_id, _ = strsplit("-",guid) 
		print(npc_id)
		for i, unitid in ipairs(unitdb.ignornpc) do
			tonumber(unitid)
			tonumber(npc_id)
			print(unitid)
			if tonumber(npc_id) == unitid then
				ignornpcid = true
			end
		end
		print(ignornpcid)
	elseif  arg == "test2" then
		
	elseif  arg == "reset" then
		for k, unitguid in ipairs(unitdb.frostwolf) do
			unitdb.units[unitguid].bar:Hide()
			unitdb.units[unitguid] = {}
			table_remove(unitdb.frostwolf, 0)
			
		end
		unitdb.frostwolf = {}
		unitdb.units = {}
	end	
end

do
	SlashCmdList["cmdut"] = cmdut; 
	SLASH_cmdut1 = "/utar";
	SLASH_cmdut2 = "/UnrealTargets";
	SLASH_cmdut3 = "/unrealtargets";
	SLASH_cmdut4 = "/unrealtarget";
end

function UnrealTargets:set_hp_frame(posix, posiy)
	local NewStatusBar = CreateFrame("StatusBar", nil, UIParent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(150)
	NewStatusBar:SetHeight(15)
	NewStatusBar:SetPoint("RIGHT",posix, posiy)
	local c = red;
	NewStatusBar:SetStatusBarColor(c.r, c.g, c.b)
	return NewStatusBar
end

function UnrealTargets:addFrame(posix, posiy, spell)
	local spellname,_,_, castTime = GetSpellInfo(spell)
	local mybar1 = UnrealTargets:set_frame(posix, posiy)
	--UnrealTargets:set_font_name(5, 0, mybar1, spellname, 16, "LEFT")
	local mybarduration1 = UnrealTargets:set_font_duartion(-2, 0, mybar1)
	return
end

function UnrealTargets:addcd(posix, posiy, width, height, spellID, srcName, charclass)
	local NewCD = CreateFrame("Frame", nil, UIParent)
	NewCD:SetPoint("TOPLEFT",1, -1)
	local icon = select(3,GetSpellInfo(spellID))
	local NewIcon = CreateFrame("StatusBar", nil, Frame)
	NewIcon:SetStatusBarTexture(icon)
	NewIcon:SetWidth(height)
	NewIcon:SetHeight(height)
	NewIcon:SetPoint("TOPLEFT",posix, posiy)
	local NewCDBar = CreateFrame("StatusBar", nil, Frame)
	NewCDBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewCDBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewCDBar:SetBackdropBorderColor(1, 1, 1, 1);
	NewCDBar:SetBackdropColor(1,1,1,0.2)
	NewCDBar:GetStatusBarTexture():SetHorizTile(false)
	NewCDBar:SetMinMaxValues(0, 100)
	NewCDBar:SetValue(100)
	NewCDBar:SetWidth(width)
	NewCDBar:SetHeight(height)
	NewCDBar:SetPoint("TOPLEFT",posix+height, posiy)
	local color = RAID_CLASS_COLORS[charclass];
	NewCDBar:SetStatusBarColor(color.r, color.g, color.b)
	local texthigh = 10
	local barname = strsplit("-",srcName);
	local NewFont = UnrealTargets:set_font_name(1, 0, NewCDBar, barname, texthigh, "LEFT")
	local NewCDFont2 = UnrealTargets:set_font_name(-1, 0, NewCDBar, "", texthigh, "RIGHT")
	--print("newcdbar")
	return NewCDBar, NewIcon, NewFont, NewCDFont2, srcName, spellID
end

function UnrealTargets:updatecd(barupd, iconupd, fontupd, cdtimeud, posix, posiy, width, height, spellID, srcName, charclass)
	barupd:Show()
	iconupd:Show()
	local icon = select(3,GetSpellInfo(spellID))
	iconupd:SetStatusBarTexture(icon)
	iconupd:SetWidth(height)
	iconupd:SetHeight(height)
	iconupd:SetPoint("TOPLEFT",posix, posiy)
	barupd:SetWidth(width)
	barupd:SetHeight(height)
	barupd:SetValue(100)
	barupd:SetPoint("TOPLEFT",posix+height, posiy)
	local color = RAID_CLASS_COLORS[charclass];
	barupd:SetStatusBarColor(color.r, color.g, color.b)
	local barname = strsplit("-",srcName);
	fontupd:SetText(barname)
	cdtimeud:SetText("")
	return barupd, iconupd, fontupd, cdtimeud, srcName, spellID
end

function UnrealTargets:set_frame(posix, posiy)
	local NewStatusBar = CreateFrame("StatusBar", nil, UIParent)
	NewStatusBar:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
	NewStatusBar:SetBackdrop({
				bgFile = "Interface/Buttons/GreyscaleRamp64",
				edgeFile = "Interface/Buttons/WHITE8X8",
				edgeSize = 1,
			});
	NewStatusBar:SetBackdropBorderColor(1,1,1,1);
	NewStatusBar:SetBackdropColor(1,1,1,0.2);
	NewStatusBar:GetStatusBarTexture():SetHorizTile(false)
	NewStatusBar:SetMinMaxValues(0, 100)
	NewStatusBar:SetValue(100)
	NewStatusBar:SetWidth(200)
	NewStatusBar:SetHeight(40)
	NewStatusBar:SetPoint("CENTER",posix, posiy)
	local c = RAID_CLASS_COLORS['DRUID'];
	NewStatusBar:SetStatusBarColor(c.r, c.g, c.b)
	return NewStatusBar
end

function UnrealTargets:updateFrame(myframe, endtime, fontstring)
	local mxvalue = endtime-GetTime()
	myframe:SetScript("OnUpdate", function(self, frame)
		local duration = endtime-GetTime()
		
		if duration <= 0 then
			myframe:Hide()
		else
			local statusvalue = duration/mxvalue *100
			myframe:SetValue(statusvalue)	
			duration=string_format("%.1f/",duration)
			mxvalue=string_format("%.1f",mxvalue)
			fontstring:SetText(duration..mxvalue)
		end
	end)
	return
end

function UnrealTargets:set_font_duartion(posix, posiy, framename)
	local fontstring = framename:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	fontstring:SetPoint("RIGHT",posix, posiy)
	fontstring:SetText("0")
	fontstring:SetFont("Fonts\\FRIZQT__.ttf",16,"OUTLINE")
	return fontstring
end

function UnrealTargets:set_font_name(posix, posiy, fontname, myname, texthigh, anocher)
	local fontstring = fontname:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	fontstring:SetPoint(anocher, posix, posiy)
	fontstring:SetText(myname)
	fontstring:SetFont("Fonts\\FRIZQT__.ttf",texthigh,"OUTLINE")
	return fontstring
end

 function UnrealTargets:OnCombatEvent(event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName,destF1,destF2,spellID,spellName,...)
	-- if spellID ~= nil and spellName ~= nil then
		-- if event == 'SPELL_CAST_SUCCESS' then
			-- for i, searchID in ipairs(allspellids) do
				-- if searchID == spellID then
					-- if raiddb.spellneedupdate[spellID] == nil then
						-- raiddb.spellneedupdate[spellID] = {}
					-- end
					-- if raiddb.spellneedupdate[spellID][srcName] == nil then
						-- raiddb.spellneedupdate[spellID][srcName] = {}
					-- end
					-- if spellID == 740 then
						-- print("cast gelassenheit")
					-- end
					-- --print(event.." "..spellName.." "..spellID)
					-- localtime = GetTime()
					-- raiddb.spellneedupdate[spellID][srcName]["uptodate"] = localtime+raiddb.cdinfos[spellID]["duration"]
					-- raiddb.spellneedupdate[spellID][srcName]["isactive"] = localtime+raiddb.cdinfos[spellID]["cd"]
					-- --table.insert(allactivcds, srcName..","..spellID..","..cdinfos[spellID]["class"])
					-- if not raiddb.allactivcds then
						 -- raiddb.allactivcds = {}
					-- end	
					
					-- raiddb.allactivcds[wide] = {}
					-- raiddb.allactivcds[wide]["name"] = srcName
					-- raiddb.allactivcds[wide]["spellID"] = spellID
					-- raiddb.allactivcds[wide]["class"] = raiddb.cdinfos[spellID]["class"]
					-- wide = wide+1
				-- --elseif event == 'SPELL_CAST_START' then
				-- end
			-- end
		-- end
	-- end
 end

function UnrealTargets:OnCombatEventDebugg(event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName,destF1,destF2,spellID,spellName,...)
	if spellID ~= nil and spellName ~= nil then
		print(event.." "..spellName.." "..spellID)
	end
end

function UnrealTargets:Initialize()

end

function UnrealTargets:OnCombatEvent_mybar(event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName,destF1,destF2,spellID,spellName,...)
	local localtime = GetTime()
	if spellID ~= nil and spellName ~= nil then
		if event == 'SPELL_CAST_START' then
			UnrealTargets:addFrame(0, 0, spellID)
		end	
	end
end

function UnrealTargets:hp_update(fontname, fonthppercent, ...)
	local unit = ...
	if unit ~= "player" then
		local health = UnitHealth(unit) / UnitHealthMax(unit) * 100
		testbar:SetValue(health)
		fontname:SetPoint("LEFT", 0, 0)
		local unitname = UnitName(unit)
		fontname:SetText(unitname)
		fontname:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
		
		health = string_format("%.0f", health)
		health = health.."%"
		
		
		fonthppercent:SetPoint("RIGHT", 0, 0)
		fonthppercent:SetText(health)
		fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
	end
	return fontname, fonthppercent
end

function UnrealTargets:hp_update2(time, event,hide,srcGUID,srcName,srcF1,srcF2,destGUID,destName, ...)
	local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",destGUID)
	local sourcetype = strsplit("-",srcGUID)
	local unit = destName
	local isindb = false;
	local targetsvalue = 0
	local ignornpcid = false
	if event == "UNIT_DIED" then
		for k, unitguid in ipairs(unitdb.frostwolf) do
			if unitguid == destGUID then
				table_remove(unitdb.frostwolf, k)
				unitdb.units[unitguid].bar:Hide()
				for j, upunitguid in ipairs(unitdb.frostwolf) do
					--if upunitguid ~= "nil" then
						--print(j.." "..upunitguid)
						unitdb.units[upunitguid].bar:SetPoint("RIGHT",-250,  0-targetsvalue*20)
						targetsvalue = targetsvalue +1
					--end
				end
			end
		end
	else
		if type == "Creature" and sourcetype == "Player" then
			for i, unitguid in ipairs(unitdb.frostwolf) do
				if unitguid == destGUID then
					if unit ~= "player" then
						if event == "SWING_DAMAGE" then
							_,_, dmg = ...
							unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
							local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
							health = string_format("%.0f", health)
							unitdb.units[destGUID].bar:SetValue(health)
							health = health.."%"
							unitdb.units[destGUID].fonthppercent:SetText(health)
						elseif event == "SPELL_DAMAGE" then
							_,_,_,_,_, dmg = ...
							unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
							local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
							health = string_format("%.0f", health)
							unitdb.units[destGUID].bar:SetValue(health)
							health = health.."%"
							unitdb.units[destGUID].fonthppercent:SetText(health)
						elseif event == "SPELL_PERIODIC_DAMAGE" then
							_,_,_,_,_, dmg = ...
							unitdb.units[destGUID].hp = unitdb.units[destGUID].hp - dmg
							local health = unitdb.units[destGUID].hp / unitdb.units[destGUID].maxhp * 100
							health = string_format("%.0f", health)
							unitdb.units[destGUID].bar:SetValue(health)
							health = health.."%"
							unitdb.units[destGUID].fonthppercent:SetText(health)
						end
					end
					isindb = true
				end
				targetsvalue = targetsvalue+1
			end
			if not isindb then
				for i, unitid in ipairs(unitdb.ignornpc) do
					if tonumber(npc_id) == unitid then
						ignornpcid = true
					end
				end
				if ignornpcid == false then
					SendChatMessage(","..npc_id.." -- "..destName, "CHANNEL", nil,  GetChannelName("myaddon"))
					--print(","..npc_id.." -- "..destName)
					table_insert(unitdb.frostwolf, destGUID)
					--unitdb.frostwolf.id = destGUID
					unitdb.units[destGUID] = {}
					if unitdb.unitsmaxhp[npc_id] then
						unitdb.units[destGUID].maxhp = unitdb.unitsmaxhp[npc_id].maxhp
					else
						unitdb.units[destGUID].maxhp = 1000000
					end
					unitdb.units[destGUID].hp = unitdb.units[destGUID].maxhp 
					unitdb.units[destGUID].bar = UnrealTargets:set_hp_frame(-250, 0-targetsvalue*20)
					--unitdb.units[destGUID].bar:SetMinMaxValues(0, 100)
					
					unitdb.units[destGUID].fontname = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].fontname:SetPoint("LEFT", 0, 0)
					unitdb.units[destGUID].fontname:SetText(destName)
					unitdb.units[destGUID].fontname:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
					unitdb.units[destGUID].fonthppercent = unitdb.units[destGUID].bar:CreateFontString(nil, "OVERLAY", "GameTooltipText")
					unitdb.units[destGUID].fonthppercent:SetPoint("RIGHT", 0, 0)
					unitdb.units[destGUID].fonthppercent:SetFont("Fonts\\FRIZQT__.ttf",11,"OUTLINE")
					--print("new! "..destGUID)
				end
			end
		end
	end
end

function UnrealTargets:npcmaxhp_update()
	local max_health = UnitHealthMax("target")
	local currenthealth = UnitHealth("target")
	if max_health ~= 0 and currenthealth ~= 0 then
		--print("true "..max_health)
		local guid = UnitGUID("target")
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",guid)
		if npc_id then
			unitdb.unitsmaxhp[npc_id] = {}
			unitdb.unitsmaxhp[npc_id].maxhp = max_health
			for i, unitguid in ipairs(unitdb.frostwolf) do
				if unitguid == guid then
					unitdb.units[guid].maxhp = max_health
					unitdb.units[guid].hp = currenthealth
					local health = unitdb.units[guid].hp / unitdb.units[guid].maxhp * 100
					health = string_format("%.0f", health)
					unitdb.units[guid].bar:SetValue(health)
					health = health.."%"
					unitdb.units[guid].fonthppercent:SetText(health)
				end
			end
		end
	end
end


UnrealTargets:SetScript("OnUpdate", function(self, frame) 
	
end)

function UnrealTargets:OnEvent(event, ...)
	if event == 'PLAYER_LOGIN' then
		--self:Initialize(...)
		--UnrealTargets:target_updates()
		--print("login")
	elseif event == 'COMBAT_LOG_EVENT_UNFILTERED' then
		self:hp_update2(...)
	elseif event == 'PLAYER_TARGET_CHANGED' then
		self:npcmaxhp_update()
	elseif event == 'UNIT_HEALTH_FREQUENT' then
		--testbar.fontname, testbar.fonthppercent = self:hp_update(testbar.fontname, testbar.fonthppercent, ...)
	end
	return
end

function OnEvent(self, event, ...)
	UnrealTargets:OnEvent(event, ...)
end



UnrealTargets:RegisterEvent('GROUP_ROSTER_UPDATE')
UnrealTargets:RegisterEvent('PLAYER_LOGIN')
UnrealTargets:RegisterEvent('UNIT_HEALTH_FREQUENT')
UnrealTargets:RegisterEvent('PLAYER_TARGET_CHANGED')
UnrealTargets:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED');
UnrealTargets:SetScript('OnEvent', OnEvent)



